=== debian/changelog ===
supernovas (1.4.1-2) experimental; urgency=medium

  * Added autopkgtest integration tests

 -- Attila Kovacs <attipaci@gmail.com>  Tue, 22 Jul 2025 15:17:00 +0200

supernovas (1.4.1-1) unstable; urgency=medium

  * Update to upstream SuperNOVAS v1.4.1
  * Fixes reverse order builds (Fixes: #1105702)

 -- Attila Kovacs <attipaci@gmail.com>  Mon, 21 Jul 2025 11:45:11 +0200
