=== debian/changelog ===
supernovas (1.4.2-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Don't autodetect calceph and cspice. (Closes: #1112635)

  [ Attila Kovacs ]
  * Mark cio-data and doc subpackages as Multi-Arch: foreign 

 -- Attila Kovacs <attipaci@gmail.com>  Thu, 28 Aug 2025 16:33:23 +0200

supernovas (1.4.2-1) unstable; urgency=medium

  * Update to upstream v1.4.2 -- bug fix release with updated nutation model.

 -- Attila Kovacs <attipaci@gmail.com>  Sun, 24 Aug 2025 19:46:14 +0200
