=== debian/control ===
Source: supernovas
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Attila Kovacs <attila.kovacs@cfa.harvard.edu>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13), libcalceph-dev
Build-Depends-Indep: doxygen
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian-astro-team/supernovas
Vcs-Git: https://salsa.debian.org/debian-astro-team/supernovas.git
Homepage: https://smithsonian.github.io/SuperNOVAS
Rules-Requires-Root: no
Testsuite: autopkgtest

Package: libsupernovas1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: libsupernovas-cio-data (= ${binary:Version})
Description: SuperNOVAS C/C++ astrometry library
 SuperNOVAS is a C/C++ astronomy library, providing high-precision astronomical
 calculations such as one might need for running an observatory or a precise
 planetarium program. It is a fork of the Naval Observatory Vector Astrometry
 Software (NOVAS) C version 3.1, providing bug fixes and making it easier to
 use overall.
 .
 The main goals of SuperNOVAS are to improve usability, add new features,
 promote best practices, and provide accessible documentation -- all while
 retaining 100% API compatibility with NOVAS C 3.1. Thus, if you have written
 code for NOVAS C 3.1, you can build it with SuperNOVAS also.
 SuperNOVAS is entirely free to use without licensing restrictions. Its source
 code is compatible with the C90 standard, and hence should be suitable for old
 and new platforms alike. It is light-weight and easy to use, with full support
 for the IAU 2000/2006 standards for sub-micro-arc-second position.

Package: libsolsys-calceph1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libsupernovas1 (= ${binary:Version}),
         libcalceph2
Description: Optional SuperNOVAS plugin library that provides Solar-system
 support via the CALCEPH C library. It allows using both JPL (SPK) and INPOP
 2.0/3.0 data files with SuperNOVAS to obtain precise locations for
 Solar-system bodies. This plugin is currently the preferred option to use for
 Fedora / RPM Linux development, which requires use of precise Solar-system
 data.

Package: libsolsys1-1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libsupernovas1 (= ${binary:Version})
Description: Legacy solar-system plugin for JPL DE200 through DE421
 Optional SuperNOVAS plugin library that provides legacy solar-system routines
 for accessing older JPL planetary data (DE200 through DE421).

Package: libsolsys2-1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libsupernovas1 (= ${binary:Version})
Description: Legacy solar-system plugin for the JPL PLEPH routines
 Optional SuperNOVAS plugin library that provides legacy solar-system routines
 for accessing older JPL planetary data through the JPL PLEPH routines. It
 requires a user-provided FORTRAN adapter module, and PLEPH library. This
 package is provided only to support legacy applications that were written for
 that particular interfacing.

Package: libsupernovas-cio-data
Architecture: all
Multi-Arch: foreign
Section: libs
Depends: ${misc:Depends}
Description: CIO location data for the SuperNOVAS C/C++ astronomy library
 Optional CIO location vs GCRS lookup table. This file is not normally
 required for the operation of the library. It is needed only if the user
 explicitly needs to know the location of the CIO vs GCRS, rather than w.r.t.
 the equinox of date.
 .
 Applications that require CIO location w.r.t. the GCRS should depend on this
 sub-package.

Package: libsupernovas-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libsupernovas1 (= ${binary:Version}),
         libsolsys-calceph1 (= ${binary:Version}),
         libsolsys1-1 (= ${binary:Version}),
         libsolsys2-1 (= ${binary:Version})
Description: C development files for the SuperNOVAS C/C++ astronomy library
 This sub-package provides C headers and non-versioned shared library symbolic
 links for the SuperNOVAS C/C++ library.

Package: libsupernovas-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Documentation for the SuperNOVAS C/C++ astronomy library
 This package provides man pages and HTML documentation for the SuperNOVAS
 C/C++ astronomy library.
