=== debian/rules ===
#!/usr/bin/make -f

export CIO_LOCATOR_FILE=/usr/share/supernovas/CIO_RA.TXT
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- CALCEPH_SUPPORT=1 CSPICE_SUPPORT=0

override_dh_installchangelogs:
	dh_installchangelogs CHANGELOG.md
